<?php

declare(strict_types=1);

namespace Dedi\SyliusMailAdminPlugin\DependencyInjection\Compiller;

use Symfony\Component\DependencyInjection\Compiler\CompilerPassInterface;
use Symfony\Component\DependencyInjection\ContainerBuilder;

class MailDefinitionPass implements CompilerPassInterface
{
    public function process(ContainerBuilder $container): void
    {
        if (!$container->has('dedi_sylius_mail_admin_plugin.form_registry.mail_definition')) {
            return;
        }

        $mailVariableConfiguration = $container->getExtensionConfig('dedi_sylius_mail_admin');
        $mailVariableRegistry = $container->getDefinition('dedi_sylius_mail_admin_plugin.form_registry.mail_definition');

        if (!empty($mailVariableConfiguration) && isset($mailVariableConfiguration[0]['mails'])) {
            foreach ($mailVariableConfiguration[0]['mails'] as $mailDefinition) {
                if (!empty($mailDefinition['variables'])) {
                    foreach ($mailDefinition['variables'] as $variableDefinition) {
                        $mailVariableRegistry->addMethodCall(
                            'addMailDefinition',
                            [$mailDefinition['code'], $variableDefinition['name'], $variableDefinition['label']]
                        );
                    }
                }
            }
        }
    }
}
