<?php

declare(strict_types=1);

namespace Dedi\SyliusMailAdminPlugin\Repository;

use Doctrine\ORM\NonUniqueResultException;

interface MailRepositoryInterface
{
    public function findByCode(string $code, ?int $excludedMailId = null): array;

    /**
     * @param string $code
     * @param string $locale
     *
     * @return mixed
     *
     * @throws NonUniqueResultException
     */
    public function findEnabledTranslatableByCode(string $code, string $locale);
}
